<template>
	<view class="content">
		<view class="homemain">
			<img class="homebg" src="https://ikea-mrm.woaap.com/images/cover/choosebg.png" />
			<img class="coverlogo" src="https://ikea-mrm.woaap.com/images/logo.png" />
			<img v-if="choose == 0" class="upload" src="https://ikea-mrm.woaap.com/images/cover/editbg1.png" />
			<view class="editbox" id="editbox" v-if="choose == 0">
				<img
					class="imgurl"
					:src="imgURL"
					alt=""
					:style="
						'transform:rotate(' +
							edit1.angle +
							'deg);left:' +
							edit1.left +
							'px;top:' +
							edit1.top +
							'px;width:' +
							edit1.zoom * edit1.width +
							'px;height:' +
							edit1.zoom * edit1.height +
							'px'
					"
					catchtouchstart="touch.start"
					catchtouchmove="touch.move"
					catchtouchend="touch.end"
					catchtouchcancel="touch.cancel"
				/>

				<!-- <img class="imgurl" :src="imgURL" alt="" :style="'transform:rotate('+ edit1.angle + 'deg) scale('+ edit1.zoom + ') ;left:'+ edit1.left + 'px;top:'+ edit1.top + 'px;height:'+ edit1.height + 'rpx'" catchtouchstart="touch.start" catchtouchmove="touch.move" catchtouchend="touch.end" catchtouchcancel="touch.cancel"> -->
			</view>
			<img v-if="choose == 1" class="upload" src="https://ikea-mrm.woaap.com/images/cover/editbg2.png" />
			<view class="editbox1" id="editbox" v-if="choose == 1">
				<img
					class="imgurl"
					:src="imgURL"
					alt=""
					:style="
						'transform:rotate(' +
							edit2.angle +
							'deg);left:' +
							edit2.left +
							'px;top:' +
							edit2.top +
							'px;width:' +
							edit2.zoom * edit2.width +
							'px;height:' +
							edit2.zoom * edit2.height +
							'px'
					"
					catchtouchstart="touch.start"
					catchtouchmove="touch.move"
					catchtouchend="touch.end"
					catchtouchcancel="touch.cancel"
				/>
				<img class="ikea" src="https://ikea-mrm.woaap.com/images/cover/ikea2.png" />
				<img class="ikea2t" src="https://ikea-mrm.woaap.com/images/cover/ikea2t.png" />
			</view>
			<view class="btngroup">
				<img @click="create" class="creatbtn" src="https://ikea-mrm.woaap.com/images/cover/creatbtn.png" />
				<img @click="again" class="again" src="https://ikea-mrm.woaap.com/images/cover/again.png" />
			</view>
			<img class="toast blinkf" v-if="isshow" src="https://ikea-mrm.woaap.com/images/cover/toast2.png" />
			<painter class="painter" :dirty="true" v-if="palette != null" :palette="palette" @imgOK="onImgOK" @imgErr="onImgErr"></painter>
			<painter class="painter" :dirty="true" v-if="palette2 != null" :palette="palette2" @imgOK="onImgOK2" @imgErr="onImgErr2"></painter>
		</view>
	</view>
</template>

<script>
import YrobotTouch from '../../static/utils/YrobotTouch.js'; //引入YrobotTouch
export default {
	data() {
		return {
			choose: JSON.parse(uni.getStorageSync('choose')), //,
			imgURL: JSON.parse(uni.getStorageSync('imgURL')),
			saveImgUrl: '',
			edit1: {
				width: 540,
				height: 0,
				left: 0,
				top: 0,
				angle: 0,
				zoom: 1
			},
			edit2: {
				width: 596,
				height: 0,
				left: 0,
				top: 0,
				angle: 0,
				zoom: 1
			},
			box1: {},
			palette: {},
			palette2: {},
			canvasScale: 3,
			isshow: true
		};
	},
	onShareAppMessage: function(res) {
		return {
			title: '定制宜家风 赢限量好礼',
			path: 'pages/cover/home',
			imageUrl: 'https://ikea-mrm.woaap.com/images/share/share_cover.jpeg'
		};
	},
	onShow() {
		getApp().td_app_sdk.event({
			id: '/cover/edit',
			label: 'pv',
			params: {}
		});
		setTimeout(() => {
			this.isshow = false;
		}, 3500);
	},
	mounted() {
		this.$nextTick(() => {
			let box = uni.createSelectorQuery().select('#editbox');
			box
				.boundingClientRect(res => {
					this.box1 = res;
					console.log(res);
				})
				.exec(() => {
					this.edit1.width = this.box1.width;
					this.edit2.width = this.box1.width;
					uni.getImageInfo({
						// src: "https://c-ssl.duitang.com/uploads/item/201902/10/2019021070014_nPVJc.thumb.700_0.png",
						src: this.imgURL,
						success: image => {
							//计算图片高度
							this.edit1.height = (this.edit1.width / image.width) * image.height;
							this.edit2.height = (this.edit2.width / image.width) * image.height;
						},
						fail(err) {
							console.log('读取图片失败：', err);
						}
					});
				});
		});
		//http://tmp/wxc8fb4c8542ebcfef.o6zAJs8HPzc6kjna6ulJ5ZCNibQo.6ZQYPE4uIXlz0d52aa384f5cc53942b47599c74f874a.jpg
		// console.log(JSON.parse(uni.getStorageSync('imgURL')))
	},
	methods: {
		editM(deltaX, deltaY) {
			if (this.choose == 0) {
				let left = this.edit1.left;
				let top = this.edit1.top;
				left = left + deltaX;
				top += deltaY;
				let jumpL = this.box1.width - this.edit1.width * this.edit1.zoom;
				let jumpT = this.box1.height - this.edit1.height * this.edit1.zoom;
				if (jumpL >= 0) {
					if (left < 0) left = 0;
					if (left >= jumpL) left = jumpL;
				} else {
					if (left <= jumpL) left = jumpL;
					if (left >= 0) left = 0;
				}

				if (jumpT > 0) {
					if (top <= 0) top = 0;
					if (top >= Math.abs(jumpT)) top = Math.abs(jumpT);
				} else {
					if (top >= 0) top = 0;
					if (top <= jumpT) top = jumpT;
				}
				this.edit1.left = left;
				this.edit1.top = top;
			} else {
				let left = this.edit2.left;
				let top = this.edit2.top;
				left = left + deltaX;
				top += deltaY;
				let jumpL = this.box1.width - this.edit2.width * this.edit2.zoom;
				let jumpT = this.box1.height - this.edit2.height * this.edit2.zoom;
				if (jumpL >= 0) {
					if (left < 0) left = 0;
					if (left >= jumpL) left = jumpL;
				} else {
					if (left <= jumpL) left = jumpL;
					if (left >= 0) left = 0;
				}

				if (jumpT > 0) {
					if (top <= 0) top = 0;
					if (top >= Math.abs(jumpT)) top = Math.abs(jumpT);
				} else {
					if (top >= 0) top = 0;
					if (top <= jumpT) top = jumpT;
				}
				this.edit2.left = left;
				this.edit2.top = top;
			}
		},
		create() {
			getApp().td_app_sdk.event({
				id: '生成专属封面',
				label: 'click'
			});
			// console.log(this.edit1)
			uni.showLoading({
				title: '为您生成封面'
			});
			this.palette.width = `${603 * this.canvasScale}rpx`;
			this.palette.height = `${825 * this.canvasScale}rpx`;
			if (this.choose == 0) {
				this.palette.views = [
					{
						type: 'rect',
						css: {
							width: `${535 * this.canvasScale}rpx`,
							height: `${500 * this.canvasScale}rpx`,
							left: `${40 * this.canvasScale}rpx`,
							top: `${204 * this.canvasScale}rpx`,
							color: '#c7c7c7'
						}
					},

					{
						type: 'image',
						url: this.imgURL,
						css: {
							width: `${this.edit1.width * this.edit1.zoom * this.canvasScale}px`,
							height: `${this.edit1.height * this.edit1.zoom * this.canvasScale}px`,
							left: (this.edit1.left + (40 / 750) * wx.getSystemInfoSync().windowWidth) * this.canvasScale + 'px',
							top: (this.edit1.top + (202 / 750) * wx.getSystemInfoSync().windowWidth) * this.canvasScale + 'px',
							rotate: this.edit1.angle
						}
					},
					{
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/cover/coverbg1.png',
						css: {
							width: `${603 * this.canvasScale}rpx`,
							height: `${825 * this.canvasScale}rpx`,
							left: 0,
							top: 0,
							rotate: 0
						}
					}
				];
			} else {
				this.palette.views = [
					{
						type: 'rect',
						css: {
							width: `${596 * this.canvasScale}rpx`,
							height: `${690 * this.canvasScale}rpx`,
							left: (5 / 750) * wx.getSystemInfoSync().windowWidth + 'px',
							top: (5 / 750) * wx.getSystemInfoSync().windowWidth + 'px',
							color: '#c7c7c7'
						}
					},
					{
						type: 'image',
						url: this.imgURL,
						css: {
							width: `${this.edit2.width * this.edit2.zoom * this.canvasScale}px`,
							height: `${this.edit2.height * this.edit2.zoom * this.canvasScale}px`,
							left: (this.edit2.left + (5 / 750) * wx.getSystemInfoSync().windowWidth) * this.canvasScale + 'px',
							top: (this.edit2.top + (5 / 750) * wx.getSystemInfoSync().windowWidth) * this.canvasScale + 'px',
							rotate: this.edit2.angle
						}
					},
					{
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/cover/coverbg2.png',
						css: {
							width: `${603 * this.canvasScale}rpx`,
							height: `${825 * this.canvasScale}rpx`,
							left: 0,
							top: 0,
							rotate: 0
						}
					},
					{
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/cover/ikea2.png',
						css: {
							width: `${505 * this.canvasScale}rpx`,
							height: `${98 * this.canvasScale}rpx`,
							left: `${50 * this.canvasScale}rpx`,
							top: `${30 * this.canvasScale}rpx`,
							rotate: 0
						}
					},
					{
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/cover/ikea2t.png',
						css: {
							width: `${338 * this.canvasScale}rpx`,
							height: `${40 * this.canvasScale}rpx`,
							left: `${50 * this.canvasScale}rpx`,
							top: `${138 * this.canvasScale}rpx`,
							rotate: 0
						}
					}
				];
			}

			console.log(this.palette);
			this.$forceUpdate();
		},
		again() {
			getApp().td_app_sdk.event({
				id: '重新选择封面',
				label: 'click'
			});
			uni.removeStorageSync('choose');
			uni.removeStorageSync('imgURL');
			uni.navigateTo({
				url: '/pages/cover/choose'
			});
		},
		onImgOK(e) {
			console.log(e.detail.path);
			this.saveImgUrl = e.detail.path;
			uni.setStorageSync('saveImgUrl', JSON.stringify(e.detail.path));
			this.imgLoad();
		},

		onImgErr(e) {
			console.log(e);
			uni.showToast({
				title: '错误错误'
			});
		},
		onImgOK2(e) {
			uni.hideLoading();
			// this.postUrl = e.detail.path
			uni.setStorageSync('postUrl', JSON.stringify(e.detail.path));
			uni.navigateTo({
				url: '/pages/cover/poster'
			});
		},
		onImgErr2(e) {
			console.log(e);
			uni.showToast({
				title: '错误错误'
			});
		},
		imgLoad() {
			this.palette2.width = `${750 * this.canvasScale}rpx`;
			this.palette2.height = `${1624 * this.canvasScale}rpx`;
			this.palette2.views = [
				{
					type: 'image',
					url: 'https://ikea-mrm.woaap.com/images/cover/choosebg.png',
					css: {
						width: `${750 * this.canvasScale}rpx`,
						height: `${1624 * this.canvasScale}rpx`,
						left: 0,
						top: 0,
						rotate: 0
					}
				},
				{
					type: 'image',
					url: this.saveImgUrl,
					css: {
						width: `${640 * this.canvasScale}rpx`,
						height: `${880 * this.canvasScale}rpx`,
						left: `${60 * this.canvasScale}rpx`,
						top: `${182 * this.canvasScale}rpx`
					}
				},
				{
					type: 'image',
					url: 'https://ikea-mrm.woaap.com/images/cover/bottom1.png',
					css: {
						width: `${640 * this.canvasScale}rpx`,
						height: `${378 * this.canvasScale}rpx`,
						left: `${60 * this.canvasScale}rpx`,
						top: `${1084 * this.canvasScale}rpx`
					}
				}
			];
			this.$forceUpdate();
		}
	},
	onLoad() {
		new YrobotTouch(this.$scope, 'touch', {
			//会创建this.touch1指向实例对象
			touchStart: evt => {
				console.log(evt);
			},
			touchMove: () => {
				if (this.choose == 0) {
					this.edit1.angle = this.edit1.angle;
					this.edit1.zoom = this.edit1.zoom;
					this.edit1.left = this.edit1.left;
					this.edit1.top = this.edit1.top;
				} else {
					this.edit2.angle = this.edit2.angle;
					this.edit2.zoom = this.edit2.zoom;
					this.edit2.left = this.edit2.left;
					this.edit2.top = this.edit2.top;
				}
			},
			touchEnd: function() {},
			touchCancel: function() {},
			multipointStart: function() {}, //一个手指以上触摸屏幕触发
			multipointEnd: function() {}, //当手指离开，屏幕只剩一个手指或零个手指触发(一开始只有一根手指也会触发)
			tap: function() {}, //点按触发，覆盖下方3个点击事件，doubleTap时触发2次
			doubleTap: function() {}, //双击屏幕触发
			longTap: function() {}, //长按屏幕750ms触发
			singleTap: function() {}, //单击屏幕触发，包括长按
			rotate: evt => {
				//evt.angle代表两个手指旋转的角度
				//console.log('rotate:' + evt.angle);
				//旋转
				if (this.choose == 0) {
					this.edit1.angle = this.edit1.angle + evt.angle;
				} else {
					this.edit2.angle = this.edit2.angle + evt.angle;
				}
			},
			pinch: evt => {
				//evt.zoom代表两个手指缩放的比例(多次缩放的累计值),evt.singleZoom代表单次回调中两个手指缩放的比例
				if (this.choose == 0) {
					//控制不能缩小
					this.edit1.zoom = evt.zoom < 1 ? 1 : evt.zoom;
				} else {
					this.edit2.zoom = evt.zoom < 1 ? 1 : evt.zoom;
				}
				// if(this.edit1.zoom * this.edit1.width > this.smileBox.width) this.edit1.zoom = this.smileBox.width / this.edit1.width
			},
			pressMove: evt => {
				//evt.deltaX和evt.deltaY代表在屏幕上移动的距离,evt.target可以用来判断点击的对象
				// console.log(evt.target);
				this.editM(evt.deltaX, evt.deltaY);
			},
			swipe: function(evt) {
				//在touch结束触发，evt.direction代表滑动的方向 ['Up','Right','Down','Left']
				//console.log("swipe:" + evt.direction);
			}
		});
	}
};
</script>

<style lang="less" scoped>
.toast {
	width: 279rpx;
	height: 97rpx;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	z-index: 999;
}
.content {
	width: 100vw;
	height: 100vh;
	position: relative;
	background: #ffffff;
	position: relative;
	overflow: hidden;
}
.homemain {
	width: 750rpx;
	height: 1624rpx;
	position: absolute;
	top: -150rpx;
	.homebg {
		width: 750rpx;
		height: 1624rpx;
		position: absolute;
		top: 0;
	}
	.upload {
		width: 750rpx;
		height: 879rpx;
		position: absolute;
		left: 0;
		top: 315rpx;
	}
	.editbox {
		position: absolute;
		width: 532rpx;
		height: 500rpx;
		background-color: #c8c8c8;
		// border: 1px solid red;
		top: 518rpx;
		left: 114rpx;
		box-sizing: border-box;
		overflow: hidden;
		.imgurl {
			position: absolute;
			width: 525rpx;
			height: auto;
		}
	}
	.editbox1 {
		position: absolute;
		width: 596rpx;
		height: 690rpx;
		// background-color:red;
		// border: 1px solid red;
		top: 318rpx;
		left: 80rpx;
		box-sizing: border-box;
		overflow: hidden;
		.imgurl {
			position: absolute;
			width: 596rpx;
			height: auto;
		}
		.ikea {
			width: 505rpx;
			height: 105rpx;
			position: absolute;
			top: 25rpx;
			left: 50rpx;
		}
		.ikea2t {
			width: 338rpx;
			height: 40rpx;
			position: absolute;
			top: 138rpx;
			left: 50rpx;
		}
	}
}
.btngroup {
	width: 100%;
	position: absolute;
	top: 1230rpx;
	height: 108upx;
	padding: 0 44upx;
	box-sizing: border-box;
	display: flex;
	flex-direction: row;
	justify-content: space-between;
	img {
		width: 316rpx;
		height: 98rpx;
	}
}
.painter {
	position: absolute;
	left: 100vw;
	z-index: 99;
}
</style>
